'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _compact2 = require('lodash/compact');

var _compact3 = _interopRequireDefault(_compact2);

var _values2 = require('lodash/values');

var _values3 = _interopRequireDefault(_values2);

var _keys2 = require('lodash/keys');

var _keys3 = _interopRequireDefault(_keys2);

var _map2 = require('lodash/map');

var _map3 = _interopRequireDefault(_map2);

var _reverse2 = require('lodash/reverse');

var _reverse3 = _interopRequireDefault(_reverse2);

var _isArray2 = require('lodash/isArray');

var _isArray3 = _interopRequireDefault(_isArray2);

var _isObject2 = require('lodash/isObject');

var _isObject3 = _interopRequireDefault(_isObject2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _forEachRight2 = require('lodash/forEachRight');

var _forEachRight3 = _interopRequireDefault(_forEachRight2);

exports.default = function (_ref) {
  var t = _ref.types;

  var addImport = function addImport(node, specifiers, module) {
    return node.body.unshift(t.importDeclaration(specifiers, t.stringLiteral(module)));
  };
  var defaultImport = function defaultImport(binding, scope) {
    return !scope.hasBinding(binding) && t.importDefaultSpecifier(t.identifier(binding));
  };
  var destructuredImport = function destructuredImport(right, left, scope) {
    return !scope.hasBinding(right) && t.importSpecifier(t.identifier(right), t.identifier(left));
  };

  var makeSpecifiers = function makeSpecifiers(bindings, scope) {
    switch (true) {
      case (0, _isArray3.default)(bindings):
        return (0, _map3.default)(bindings, function (binding) {
          return destructuredImport.apply(undefined, _toConsumableArray((0, _isObject3.default)(binding) ? [(0, _values3.default)(binding)[0], (0, _keys3.default)(binding)[0], scope] : [binding, binding, scope]));
        });
      case (0, _isObject3.default)(bindings):
        return [].concat(_toConsumableArray(makeSpecifiers(bindings.default, scope)), _toConsumableArray(makeSpecifiers(bindings.destructured, scope)));
      default:
        return [defaultImport(bindings, scope)];
    }
  };

  return {
    visitor: {
      Program: {
        exit: function exit(_ref2, _ref3) {
          var node = _ref2.node;
          var scope = _ref2.scope;
          var opts = _ref3.opts;

          if ((0, _isEmpty3.default)(opts)) return;
          (0, _forEachRight3.default)(opts, function (bindings, module) {
            var specifiers = (0, _compact3.default)(makeSpecifiers(bindings, scope));
            if (specifiers.length) addImport(node, specifiers, module);
          });
        }
      }
    }
  };
};

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }